(function ($) {
  'use strict';
  Drupal.behaviors.google_place_autocomplete = {
    attach: function (context, settings) {
      if (!drupalSettings.google_place_autocomplete) {
        return;
      }
      /**
       * Initialize Google Places Autocomplete.
       */
      function initializeAutocomplete() {
        // Loop over autocomplete fields
        $('input[data-google-places-autocomplete]').each(function () {
          let input = $(this);
          // Setup options
          let options = {
            Fields: ['address_component', 'formatted_address'],
          };
          if (drupalSettings.google_place_autocomplete.elements[input.attr('id')]) {
            if (drupalSettings.google_place_autocomplete.elements[input.attr('id')].options.types) {
              options['types'] = [drupalSettings.google_place_autocomplete.elements[input.attr('id')].options.types];
            }
            if (drupalSettings.google_place_autocomplete.elements[input.attr('id')].options.country) {
              options['componentRestrictions'] = {country: drupalSettings.google_place_autocomplete.elements[input.attr('id')].options.country};
            }
          }
          let autocomplete = new google.maps.places.Autocomplete(this, options);
          autocomplete.addListener('place_changed', function () {
            let place = autocomplete.getPlace();
            if (place) {
              $.each(place.address_components, function (index, value) {
                let addressType = value.types[0];
                if (addressType === 'postal_code' || addressType === "postal_code_prefix") {
                  if (value.short_name) {
                    let current_address = input.val();
                    if (!current_address.includes(value.short_name)) {
                      input.val(current_address + ' ' + value.short_name);
                    }
                  }
                }
              });
            }
          });
        });
      }
      google.maps.event.addDomListener(window, 'load', initializeAutocomplete);
    }
  };
})(jQuery);
